//modified:2002.03.05@19:26 by Alex

//HISTORY:
//========
//2002.03.05:
//* DecodeText/EncodeText hinzugefgt

unit UnitMy;

interface

uses
  Registry, Math, SysUtils;

  function DeCodeText(text:String):string;
  function EncodeText(text:string):string;

type
  TMyRegistry = class(TRegistry)
    function ReadStringD(key:string;default:string):string;
    function ReadIntegerD(key:string;default:integer):integer;
    function ReadDateTimeD(key:string;default:TDateTime):TDateTime;
    function ReadFloatD(key:string;default:double):double;
    function ReadBoolean(key:string;default:boolean):boolean;
    procedure WriteBoolean(key:string;value:boolean);
  end;


implementation

////////////////////////////////////////////////////////////////////////////////
//////////////////////////////  MY REGISTRY  ///////////////////////////////////

function TMyRegistry.ReadStringD(key:string;default:string):string;
begin
  if ReadString(key)='' then
    result:=default
  else
    result:=ReadString(key);
end;

function TMyRegistry.ReadIntegerD(key:string;default:integer):integer;
begin
  if not ValueExists(key) then
    result:=default
  else
    try
      result:=ReadInteger(key);
    except
      result:=default;
    end;
end;

function TMyRegistry.ReadDateTimeD(key:string;default:TDateTime):TDateTime;
begin
  if not ValueExists(key) then
    result:=default
  else
    try
      result:=ReadDateTime(key);
    except
      result:=default;
    end;
end;

function TMyRegistry.ReadFloatD(key:string;default:double):double;
begin
  if not ValueExists(key) then
    result:=default
  else
    try
      result:=ReadFloat(key);
    except
      result:=default;
    end;
end;

function TMyRegistry.ReadBoolean(key:string;default:boolean):boolean;
begin
  if not ValueExists(key) then
    result:=default
  else
    try
      result:=(ReadString(key)='true') or (ReadString(key)='yes');
    except
      result:=default;
    end;
end;

procedure TMyRegistry.WriteBoolean(key:string;value:boolean);
begin
  if value then
    WriteString(key,'true')
  else
    WriteString(key,'false');
end;

//////////////////////////////  MY REGISTRY  ///////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

function DeCodeText(text:String):string;
var
  i,j : integer;
  a   : string;
begin
  i:=1;
  while i<=length(text) do begin
    case text[i] of
      '#':if text[i+1]='#' then begin
            a:=a+'#';
            inc(i);
          end else begin
            j:=i+1;
            while (j<=length(text)) and (text[j]<>'>') and
                  ((text[j]>='0') and (text[j]<='9')) do inc(j);
            if j>i+1 then
              a:=a+chr(strtoint(copy(text,i+1,min(3,j-i-1))))
            else
              a:=a+'#';
            inc(i,min(3,j-i-1));
          end;
      '<':begin
          inc(i);
          if text[i]='<' then begin
            a:=a+'<';
            dec(i);
          end else begin
            j:=i;
            while (j<=length(text)) and (text[j]<>'>') and
                  ((text[j]>='0') and (text[j]<='9')) do inc(j);
            if j>i then begin
              a:=a+chr(strtoint(copy(text,i,min(3,j-i))));
              inc(i,min(3,j-i));
              if text[i]<>'>' then dec(i);
            end else begin
              a:=a+'<';
              dec(i);
            end;
          end;
        end;
      else
        a:=a+text[i];
    end;
    inc(i);
  end;
  result:=a;
end;

function EncodeText(text:string):string;
//replaces chars<#32 and >#127 by their asc values
var
  i : integer;
  b : string;
begin
  for i:=1 to length(text) do
    if (text[i]<#32) or (text[i]>#127) then
      b:=b+'<'+inttostr(ord(text[i]))+'>'
    else
      b:=b+text[i];
  result:=b;
end;

end.
